# This file was auto-generated by Fern from our API Definition.

from __future__ import annotations
from ...core.unchecked_base_model import UncheckedBaseModel
import typing
from .user_message_content import UserMessageContent
from ...types.chat_document import ChatDocument
from ...core.pydantic_utilities import IS_PYDANTIC_V2
import pydantic
from .tool_call2 import ToolCall2
from .assistant_message_content import AssistantMessageContent
from .citation import Citation
from .system_message_content import SystemMessageContent
from .tool_message2tool_content_item import ToolMessage2ToolContentItem
import typing_extensions
from ...core.unchecked_base_model import UnionMetadata


class ChatMessage2_User(UncheckedBaseModel):
    """
    Represents a single message in the chat history from a given role.
    """

    role: typing.Literal["user"] = "user"
    content: UserMessageContent
    documents: typing.Optional[typing.List[ChatDocument]] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow


class ChatMessage2_Assistant(UncheckedBaseModel):
    """
    Represents a single message in the chat history from a given role.
    """

    role: typing.Literal["assistant"] = "assistant"
    tool_calls: typing.Optional[typing.List[ToolCall2]] = None
    tool_plan: typing.Optional[str] = None
    content: typing.Optional[AssistantMessageContent] = None
    citations: typing.Optional[typing.List[Citation]] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow


class ChatMessage2_System(UncheckedBaseModel):
    """
    Represents a single message in the chat history from a given role.
    """

    role: typing.Literal["system"] = "system"
    content: SystemMessageContent

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow


class ChatMessage2_Tool(UncheckedBaseModel):
    """
    Represents a single message in the chat history from a given role.
    """

    role: typing.Literal["tool"] = "tool"
    tool_call_id: str
    tool_content: typing.List[ToolMessage2ToolContentItem]

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow


ChatMessage2 = typing_extensions.Annotated[
    typing.Union[ChatMessage2_User, ChatMessage2_Assistant, ChatMessage2_System, ChatMessage2_Tool],
    UnionMetadata(discriminant="role"),
]
