# This file was auto-generated by Fern from our API Definition.

from ...core.unchecked_base_model import UncheckedBaseModel
from .user_message_content import UserMessageContent
import pydantic
import typing
from ...types.chat_document import ChatDocument
from ...core.pydantic_utilities import IS_PYDANTIC_V2


class UserMessage(UncheckedBaseModel):
    """
    A message from the user.
    """

    content: UserMessageContent = pydantic.Field()
    """
    The content of the message. This can be a string or a list of content blocks.
    If a string is provided, it will be treated as a text content block.
    """

    documents: typing.Optional[typing.List[ChatDocument]] = pydantic.Field(default=None)
    """
    Documents seen by the model when generating the reply.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
